<p>This code is used to generate a FHIR knowledge graph with mappings to other data sources</p>

<p><strong>Prerequisites</strong></p>

<ul>
	<li>Neo4j is installed and set up <a href="https://neo4j.com/docs/operations-manual/current/installation/">https://neo4j.com/docs/operations-manual/current/installation/</a></li>
	<li>Python 3.6+ is installed <a href="https://www.python.org/downloads/">https://www.python.org/downloads/</a></li>
	<li>The neo4j driver is installed for python
	<ul>
		<li><em>pip install -r requirements.txt</em>&nbsp; or <em>pip install neo4j</em></li>
	</ul>
	</li>
	<li>A copy of the FHIR JSON schema is downloaded and extracted
	<ul>
		<li>It can be accessed from here: <a href="http://hl7.org/fhir/fhir.schema.json.zip">http://hl7.org/fhir/fhir.schema.json.zip</a></li>
	</ul>
	</li>
</ul>

<p><strong>Steps</strong></p>

<ul>
	<li>Run `<em>fhir_schema_read.py</em>` to generate template mapping csv files which can be used to map external data source properties to FHIR. Save all files into the `ASSETS` directory. Sample Mapping files for MIMIC and diabetes dataset are already provided.</li>
	<li>When the mapping file is constructed call `<em>export_to_neo4j.py</em>` to construct a knowledge graph in neo4j from these mappings.</li>
</ul>

<p>&nbsp;</p>

<p><strong>To note</strong></p>

<ul>
	<li>This dump contains the code and schemas of the related files. Depending on the properties available between data sources manual annotation may be required. In addition, the &quot;on&quot; column within the mapping files can be used to further regulate integration.</li>
	<li>The MIMIC data is accessible from <a href="https://physionet.org/content/mimiciii/1.4/">https://physionet.org/content/mimiciii/1.4/</a></li>
	<li>The Diabetes data used is from <a href="https://archive.ics.uci.edu/ml/datasets/Diabetes">https://archive.ics.uci.edu/ml/datasets/Diabetes</a></li>
</ul>

<p>&nbsp;</p>
