from neo4j import GraphDatabase
import os


"""
This file will read all mapping csv files inside the ASSETS folder and 
construct a graph database in Neo4j.
"""


uri = '' # blot:/ uri to neo4j instance
user = ''# neo4j username
password = ''# neo4j password

driver = GraphDatabase.driver(uri, auth=(user, password))

files = []
for file in os.listdir("Assets"):
    if file.endswith(".csv"):
        files.append(file.strip())
print(files)


def __run_query__(tx, query):
    res = tx.run(query)


def run_query(query):
    with driver.session() as session:
        greeting = session.write_transaction(__run_query__, query)


prepstat = """
LOAD CSV WITH HEADERS FROM 'file:///{}'"""

q1 = """AS row
foreach(ign in CASE WHEN row.column_1 is not null then [1] else [] end |
MERGE(s:Source {source_name: row.source_name_1})
MERGE(t:Table {table_name: row.source_name_1+"."+row.table_name_1})
MERGE(c:Column {column_name: row.source_name_1+"."+row.table_name_1+"."+row.column_1})
MERGE (s)-[r:COMPOSED_OF]->(t)
MERGE (t)-[r2:PROPERTY_OF]->(c)
foreach(ignoreme in CASE WHEN row.column_2 is not NULL THEN [1] else [] end |
MERGE(x:SOURCE {source_name: row.source_name_2})
MERGE(y:Table {table_name: row.source_name_2+"."+row.table_name_2})
MERGE(z:Column {column_name: row.source_name_2+"."+row.table_name_2+"."+row.column_2})
MERGE (x)-[r3:COMPOSED_OF]->(y)
MERGE (y)-[r4:PROPERTY_OF]->(z)
MERGE(m:MAPPING {condition:row.map_on, from: row.source_name_1+"."+row.table_name_1+"."+row.column_1})
MERGE (c)-[r5:MAPS]->(m)
MERGE (m)-[r6:MAPS]->(z)))
"""


for j in files:
    qq = prepstat.format(j)+q1
    print(qq)
    run_query(qq)